%option noyywrap

digit [0-9]
letter [a-zA-Z]
hexLetter [A-F]
id ({letter}|{escape})({letter}|{escape})*
scheme {id}
ip {digit}{1,3}\.{digit}{1,3}\.{digit}{1,3}\.{digit}{1,3}
domainName {id}({id}\.{id})*
domain {domainName}|{ip}
alternativePort {digit}{digit}*
escape \%({digit}|{hexLetter})({digit}|{hexLetter})?
anchor {id}{digit}*
path {id}
filename {id}
filetype {id}
newLine \n|\r|\r\n

url {scheme}\:\/\/{domain}(\:{alternativePort})?(\/)({path}\/)*({filename}\.{filetype})?(\#{anchor})?
%%

{url} {printf("URL detected: %s\n", yytext);}
.+ {printf("Error: %s\n", yytext);}
{newLine} {;}

%%
int main(int argc, char const *argv[]) {
  yyin = fopen(argv[1], "r");
  yylex();
  fclose(yyin);
  return 0;
}
